/*
 * CCVisu is a tool for visual graph clustering
 * and general force-directed graph layout.
 * This file is part of CCVisu.
 *
 * Copyright (C) 2005-2012  Dirk Beyer
 *
 * CCVisu is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * CCVisu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with CCVisu; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Please find the GNU Lesser General Public License in file
 * license_lgpl.txt or http://www.gnu.org/licenses/lgpl.txt
 *
 * Dirk Beyer    (firstname.lastname@uni-passau.de)
 * University of Passau, Bavaria, Germany
 */
package org.sosy_lab.ccvisu.writers;

import java.io.PrintWriter;

import org.sosy_lab.ccvisu.Options;
import org.sosy_lab.ccvisu.graph.GraphData;
import org.sosy_lab.ccvisu.graph.GraphEdge;
import org.sosy_lab.ccvisu.graph.GraphVertex;

/**
 * Writer for graphs in GraphML format.
 */
public class WriterDataGraphGXL extends WriterData {

  public WriterDataGraphGXL(PrintWriter out, GraphData graph) {
    super(out, graph);
  }

  /**
   * Writes the graph data in RSF (relational standard format).
   */
  @Override
  public void write() {
    // Header
    out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    out.println("<!-- Generated by " + Options.toolDescription() + " -->");
    out.println("<!-- " + Options.currentDateTime() + " -->");
    // "<!DOCTYPE gxl SYSTEM \"http://www.gupro.de/GXL/gxl-1.0.dtd\">" + WriterData.endl
    out.println("<gxl xmlns:xlink=\"http://www.w3.org/1999/xlink\">");

    out.println("  <graph id=\"generated-instance\" edgeids=\"true\" "
        + "edgemode=\"undirected\" hypergraph=\"false\">");

    // Vertices
    for (GraphVertex vertex : graph.getVertices()) {
      out.println(String.format("<node id=\"%s\"></node>", vertex.getName()));
    }

    // Edges
    for (GraphEdge edge : graph.getEdges()) {
      out.println(String.format("<edge from=\"%s\" to=\"%s\" isdirected=\"false\" id=\"%s\"></edge>",
          edge.getSource().getName(),
          edge.getTarget().getName(),
          "e" + edge.getSource().getName() + "-" + edge.getTarget().getName()));
    }

    // Footer
    out.println("  </graph>");
    out.println("</gxl>");

    out.flush();
  }
}
